
#ifndef _NV_NERVJIT_H_
#define _NV_NERVJIT_H_

#include <llvm_common.h>

namespace nv
{

struct NervJITImpl;

class NVLLVM_EXPORT NervJIT
{
public:
    enum HeaderType {
        HEADER_SYSTEM,
        HEADER_ANGLED,
        HEADER_QUOTED,
    };

private:
    NervJITImpl* impl;

public:

    NervJIT();
    ~NervJIT();

    void loadModuleFromFiles(const FileList& files) {
        for(auto& f: files) {
            loadModuleFromFile(f);
        }
    }

    void clearMacroDefinitions();
    void addMacroDefinition(std::string val);
    void addMacroDefinition(const std::string& key, const std::string& val) {
        addMacroDefinition(key+"="+val);
    }
    
    void clearHeaderSearchPaths();
    void addHeaderSearchPath(std::string path, HeaderType htype);

    void loadModuleFromFile(const std::string& file);

    void loadModuleFromBuffer(const std::string& buffer);
    
    uint64_t lookup(const std::string& name);

    void addCurrentProcess();
    void addDynamicLib(const char* filename);
};

};

#endif
